﻿namespace Scripts.Waypoints
{
    using System.Collections;
    using System.Collections.Generic;
    using UnityEngine;
    using Mapbox.Utils;
    using Mapbox.Directions;
    using Mapbox.Unity;
    using UnityEngine.UI;

    using Mapbox.Json;
    using Mapbox.Utils.JsonConverters;
    using Mapbox.Unity.Map;
    using Mapbox.Unity.Utilities;

    public class WaypointsFactory : MonoBehaviour
    {
        public static List<Transform> points;
        public string coordonnee1;
        public string coordonnee2;
        private const string JSON_FILE = "test.json";
        public Transform _prefab;
        public Transform _prefabs_parent;
        private AbstractMap abstractmap;
        Directions _directions;
        private GameObject map;
        private static WaypointsFactory instance;

        Vector2d[] _coordinates;

        DirectionResource _directionResource;
        public Text infoJson;
        private DirectionsResponse DirectionResourceResultat;
        private bool test = true;

        void Start()
        {
            instance = this;
            map = GameObject.Find("Map");
            abstractmap = map.GetComponent<AbstractMap>();
            points = new List<Transform>();
            coordonnee1 = "";
            coordonnee2 = "";
            _directions = MapboxAccess.Instance.Directions;

            _coordinates = new Vector2d[2];

            // Can we make routing profiles an enum?
            _directionResource = new DirectionResource(_coordinates, RoutingProfile.Driving);
            _directionResource.Steps = true;
        }

        public static WaypointsFactory getInstance()
        {
            return instance;
        }

        public bool getTest()
        {
            return test;
        }

        public List<Transform> getWp()
        {
            return points;
        }

        void Route()
        {
            //_coordinates[0] = new Vector2d(double.Parse(coordonnee1.Split(',')[0]), double.Parse(coordonnee1.Split(',')[1]));
            _coordinates[0] = Conversions.StringToLatLon(coordonnee1);
            _coordinates[1] = Conversions.StringToLatLon(coordonnee2);
            _directionResource.Coordinates = _coordinates;
            _directions.Query(_directionResource, HandleDirectionsResponse);
        }

        void HandleDirectionsResponse(DirectionsResponse res)
        {
            DirectionResourceResultat = res;
            var data = JsonConvert.SerializeObject(res, Formatting.Indented, JsonConverters.Converters);
            //infoJson.text = res.Routes[0].Legs[0].Steps[0].Intersections[0].Location.ToString();
            System.IO.File.WriteAllText(Application.dataPath + "\\" + JSON_FILE, data);
            test = false;
        }

        public void click(string coord1, string coord2)
        {
            coordonnee1 = coord1;
            coordonnee2 = coord2;
            Debug.Log(coordonnee1);
            Debug.Log(coordonnee2);
            StartCoroutine(createRoad());
        }


        IEnumerator createRoad()
        {
            if (coordonnee1 == "" || coordonnee2 == "")
            {

            }
            else
            {
                Route();
                /*
                dynamic array = JsonConvert.DeserializeObject<string>(JSON_FILE);
                foreach (var item in array)
                {
                    Thread.Sleep(1);
                    infoJson.text = item.routes + "|" + item.legs;
                    //Debug.Log(item.routes + item.legs);
                }*/
                yield return new WaitUntil(() => test == false);

                foreach (var val in DirectionResourceResultat.Routes[0].Legs[0].Steps)
                {
                    foreach (var inter in val.Intersections)
                    {
                        PlacementWaypoint(inter.Location);
                    }
                }
            }

        }

        void PlacementWaypoint(Vector2d coordonnesPoints)
        {
            points.Add(Instantiate(_prefab, new Vector3(abstractmap.GeoToWorldPosition(coordonnesPoints).x, 1, abstractmap.GeoToWorldPosition(coordonnesPoints).z), new Quaternion(0, 0, 0, 0), _prefabs_parent) as Transform);
            /*points = new Transform[transform.childCount];
            for (int i = 0; i <1; i++)
            {
                Transform newGameObj = Instantiate(_prefab, new Vector3(0, 0, 0), new Quaternion(0, 0, 0, 0)) as Transform;
                points[i] = transform.GetChild(i);
            }*/
        }
    }
}